#!/usr/bin/python

# ./svg_levels.py >svg_levels.lua

import os, glob
from lxml import etree
from lxml.cssselect import CSSSelector

print '-- autogenerated by svg_levels.py\n\nsvg_objects = {'

ns = {'svg': 'http://www.w3.org/2000/svg',
      'ink': 'http://www.inkscape.org/namespaces/inkscape'}

for svg in glob.glob('data/*.svg'):
    t = etree.parse(svg)
    basefile = os.path.basename(svg).split('.')[0]
    print '%s = {' % basefile

    sel = CSSSelector('svg|rect[ink|label="displace"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        print """
Displacer:new{
  x = %f, y = %f,
  width = %f, height = %f
},
""" % (x,y,w,h)

    sel = CSSSelector('svg|rect[ink|label="transition"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))
        w, h = float(e.get('width')), float(e.get('height'))

        desc = ""
        descSel = CSSSelector('svg|desc', ns)
        for d in descSel(e):
            desc = desc + d.text

        print """
Transition:new{
  x = %f, y = %f,
  width = %f, height = %f,
  %s
},
""" % (x,y,w,h, desc)

    sel = CSSSelector('svg|rect[ink|label="flower"]', ns)
    for e in sel(t):
        x, y = float(e.get('x')), float(e.get('y'))

        print """
Flower:new{
  x = %f, y = %f,
},
""" % (x,y)

    print '},'

print '}'
